unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Normalize, ExtCtrls, GradProgress, FileCtrl, MPlayer;
  
type
  TForm1 = class(TForm)
    Normalize1: TNormalize;
    MediaPlayer1: TMediaPlayer;
    Panel1: TPanel;
    Label1: TLabel;
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Label2: TLabel;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    GradProgress1: TGradProgress;
    procedure Button1Click(Sender: TObject);
    procedure Normalize1StateChanged(State: TState);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Normalize1Progress(PercentDone: Integer);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
    Procedure PlaySound;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  T: TDateTime;
  ExePath: string;
  Sound: string;
implementation

{$R *.DFM}

procedure TForm1.PlaySound;
begin
  Button2.Enabled := False;
  with MediaPlayer1 do begin
    Open;
    Wait := True;
    Play;
    Close;
  end;
  Button2.Enabled := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
var Ix: integer;
begin
  CopyFile(PChar(Sound),PChar(ExePath + 'SoundCopy.wav'),False);
  Normalize1.FileName := ExePath + 'SoundCopy.wav';
  MediaPlayer1.FileName :=  Normalize1.FileName;
  Button1.Enabled := False;
  Button4.Enabled := False;
  Label1.Caption := 'Playing sound before normalizing';
  Label2.Caption := '';
  Application.ProcessMessages;
  PlaySound;
  Normalize1.Execute;
  Label2.Caption := '';
  For Ix := 1 to Normalize1.ChannelCount do
    Label2.Caption := Label2.Caption + IntToStr(Normalize1.dBChange[Ix]) + '/';
  Label2.Caption := Copy(Label2.Caption,0,length(Label2.Caption)-1) + ' db added';
  Label1.Caption := '';
end;  

procedure TForm1.Normalize1StateChanged(State: TState);
var StateMsg: string;
begin
  Case State of 
    nsReading:       StateMsg := 'Reading file';
    nsWriting:       StateMsg := 'Writing file';
    nsNormalizing:   StateMsg := 'Normalizing';
    nsReady:         StateMsg := 'Ready';
    nsNone:          StateMsg := 'None';
    nsNotSupported:  StateMsg := 'Not supported';
    nsAborted:       StateMsg := 'Operation Aborted';
    nsOpenError:     StateMsg := 'File open error';
  end;
  Label1.Caption := StateMsg;                                     
  if State = nsReady then begin
    GradProgress1.Position := 0;
    Label1.Caption := 'Playing sound after normalizing';
    Application.ProcessMessages;
    PlaySound;
    Button1.Enabled := True;
    Button4.Enabled := True;
 end;  
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Normalize1.Abort := True;
  Button1.Enabled := True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Normalize1.Abort := True;
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Label1.Caption := '';
  Label2.Caption := '';
  ExePath := ExtractFilePath(Application.ExeName);
  Sound := ExePath + 'Sound.wav';
  Button4.Enabled := False;
end;

procedure TForm1.Normalize1Progress(PercentDone: Integer);
begin
  GradProgress1.Position := PercentDone;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if OpenDialog1.Execute then Sound := OpenDialog1.FileName;
end;



end.
